function model=train_karma(x,y,lambda,gamma)

n=size(x,1);
d=size(x,2);
support=zeros(size(x,1),1);
f=zeros(size(x,1),1);
epoch=0;
gap=inf;
aka=0;
msg=[];
batch=1e4;
while gap>1e-3 && epoch<inf
    epoch=epoch+1;
    shuffle=randperm(n);
    for iBatch=1:batch:n
        IL=shuffle(iBatch:min(iBatch+batch,end));  %%Calculating kernel
        k=create_kernel(x,x(IL,:),gamma);
        if gap<1e-3; break;end
        %% Choose coordinate
        %Stochastic.
        for iCoor=iBatch:min(iBatch+batch,n)
            il=IL(iCoor-iBatch+1);
            %% Calculate Update
            G= y(il)*f(il)-1;
            alpha=support(il);
            newAlpha=min(max(alpha-G/k(il,iCoor+1-iBatch),0),1/(lambda*n));
            update=newAlpha-alpha;
            %% Update aka, f and support
            aka=aka+2*y(il)*update*f(il)+update^2*k(il,iCoor+1-iBatch);% Update alpha K alpha
            f=f+y(il)*update*k(:,iCoor+1-iBatch);%update function
            support(il)=support(il)+update; %update support coefficient.
        end
        
        
    end
    %% Calculate gap.
    dualLoss= -lambda/2*aka + lambda*sum(support);
    primalLoss= lambda/2*aka + mean(max(1-y(1:n).*f(1:n),0));
    gap=primalLoss-dualLoss;
    fprintf(repmat('\b',1,numel(msg)));
    msg=sprintf('epoch: %d |w|2 = %.3f primObj= %.00e gap %.00e',epoch,aka,primalLoss,gap);
    fprintf(msg);
    
    
    
    
end
fprintf(repmat('\b',1,numel(msg)));
fprintf('|w|2 = %.3f primObj= %.00e gap %.00e epochs: %d \n',aka,primalLoss,gap,epoch);
supportVector=support~=0;
model.x=x(supportVector,:);
model.alpha=y(supportVector).*support(supportVector);
model.gamma=gamma;

